Index: branches/new_class_id/src/lib/particles/plane_emitter.cc
===================================================================
--- branches/new_class_id/src/lib/particles/plane_emitter.cc	(revision 9707)
+++ branches/new_class_id/src/lib/particles/plane_emitter.cc	(revision 9709)
@@ -26,6 +26,6 @@
 #include "class_id.h"
 
-CREATE_FACTORY(PlaneEmitter, CL_PLANE_EMITTER);
 NewObjectListDefinitionID(PlaneEmitter, CL_PLANE_EMITTER);
+CREATE_FACTORY(PlaneEmitter);
 
 /**
Index: branches/new_class_id/src/lib/particles/spark_particles.cc
===================================================================
--- branches/new_class_id/src/lib/particles/spark_particles.cc	(revision 9707)
+++ branches/new_class_id/src/lib/particles/spark_particles.cc	(revision 9709)
@@ -26,6 +26,6 @@
 #include "class_id.h"
 
-CREATE_FACTORY(SparkParticles, CL_SPARK_PARTICLES);
 NewObjectListDefinitionID(SparkParticles, CL_SPARK_PARTICLES);
+CREATE_FACTORY(SparkParticles);
 
 /**
Index: branches/new_class_id/src/lib/particles/sprite_particles.cc
===================================================================
--- branches/new_class_id/src/lib/particles/sprite_particles.cc	(revision 9707)
+++ branches/new_class_id/src/lib/particles/sprite_particles.cc	(revision 9709)
@@ -26,6 +26,6 @@
 #include "class_id.h"
 
-CREATE_FACTORY(SpriteParticles, CL_SPRITE_PARTICLES);
 NewObjectListDefinitionID(SpriteParticles, CL_SPRITE_PARTICLES);
+CREATE_FACTORY(SpriteParticles);
 
 SHELL_COMMAND(texture, SpriteParticles, setMaterialTexture)
Index: branches/new_class_id/src/lib/physics/fields/gravity.cc
===================================================================
--- branches/new_class_id/src/lib/physics/fields/gravity.cc	(revision 9707)
+++ branches/new_class_id/src/lib/physics/fields/gravity.cc	(revision 9709)
@@ -24,5 +24,5 @@
 NewObjectListDefinitionID(Gravity, CL_FIELD_GRAVITY);
 
-CREATE_FACTORY(Gravity, CL_FIELD_GRAVITY);
+CREATE_FACTORY(Gravity);
 
 Gravity::Gravity(const TiXmlElement* root)
Index: branches/new_class_id/src/lib/physics/physics_connection.cc
===================================================================
--- branches/new_class_id/src/lib/physics/physics_connection.cc	(revision 9707)
+++ branches/new_class_id/src/lib/physics/physics_connection.cc	(revision 9709)
@@ -28,7 +28,6 @@
 
 #include "class_id.h"
-
-CREATE_FACTORY(PhysicsConnection, CL_PHYSICS_CONNECTION);
 NewObjectListDefinition(PhysicsConnection);
+CREATE_FACTORY(PhysicsConnection);
 /**
  *  creates a PhysicsConnection
Index: branches/new_class_id/src/lib/script_engine/script_class.h
===================================================================
--- branches/new_class_id/src/lib/script_engine/script_class.h	(revision 9707)
+++ branches/new_class_id/src/lib/script_engine/script_class.h	(revision 9709)
@@ -29,8 +29,4 @@
 public:
   virtual ~ScriptClass();
-
-  const std::string& getName() const { return this->getName(); }
-  bool operator==(const std::string& name) const { return (this->getName() == name); }
-  bool operator==(NewClassID classID) const { return (this->_classID == classID); }
 
   virtual void registerClass(Script* script) = 0;
Index: branches/new_class_id/src/lib/shell/shell_completion.cc
===================================================================
--- branches/new_class_id/src/lib/shell/shell_completion.cc	(revision 9707)
+++ branches/new_class_id/src/lib/shell/shell_completion.cc	(revision 9709)
@@ -141,7 +141,9 @@
       type = ClassCompletion;
 
-    /// FIXME
-//     if (!this->addToCompleteList(*boList, objectBegin, type))
-//       return false;
+    NewObjectListBase::base_list list;
+    objectList->getBaseObjectList(&list);
+
+    if (!this->addToCompleteList(list, objectBegin, type))
+     return false;
 
     return true;
Index: branches/new_class_id/src/lib/shell/some_shell_commands.cc
===================================================================
--- branches/new_class_id/src/lib/shell/some_shell_commands.cc	(revision 9707)
+++ branches/new_class_id/src/lib/shell/some_shell_commands.cc	(revision 9709)
@@ -34,8 +34,8 @@
   SHELL_COMMAND(nick, PlayerStats, shellNick)->setAlias("nick");
 
-#include "class_list.h"
-  SHELL_COMMAND(debug, ClassList, ClassList::debugS)
-      ->describe("Shows all registered classes, if param1: is a valid ClassName only values of this class are shown. param2: how much output")
-      ->defaultValues(MT_NULL, 1);
+// #include "class_list.h"
+//   SHELL_COMMAND(debug, ClassList, ClassList::debugS)
+//       ->describe("Shows all registered classes, if param1: is a valid ClassName only values of this class are shown. param2: how much output")
+//       ->defaultValues(MT_NULL, 1);
 
 #include "p_node.h"
Index: branches/new_class_id/src/lib/util/Makefile.am
===================================================================
--- branches/new_class_id/src/lib/util/Makefile.am	(revision 9707)
+++ branches/new_class_id/src/lib/util/Makefile.am	(revision 9709)
@@ -2,5 +2,12 @@
 include $(MAINSRCDIR)/defs/include_paths.am
 
-noinst_LIBRARIES = libORXlibutil.a
+noinst_LIBRARIES = \
+		libORXlibutil.a \
+		libORXexecutor.a
+
+libORXexecutor_a_SOURCES = \
+		executor/executor.cc \
+		executor/executor_functional.cc \
+		executor/executor_lua.cc
 
 libORXlibutil_a_SOURCES = \
@@ -9,7 +16,4 @@
 		helper_functions.cc \
 		multi_type.cc \
-		executor/executor.cc \
-		executor/executor_functional.cc \
-		executor/executor_lua.cc \
 		\
 		loading/resource_manager.cc \
@@ -19,5 +23,5 @@
 		loading/load_param_description.cc \
 		loading/factory.cc \
-		loading/dynamic_loader.cc \
+		loading/fast_factory.cc \
 		\
 		filesys/file.cc \
@@ -28,4 +32,6 @@
 		threading.cc \
 		timer.cc
+
+#		loading/dynamic_loader.cc
 
 
@@ -55,4 +61,5 @@
 		loading/load_param_description.h \
 		loading/factory.h \
+		loading/fast_factory.h \
 		loading/dynamic_loader.h \
 		\
Index: branches/new_class_id/src/lib/util/loading/dynamic_loader.cc
===================================================================
--- branches/new_class_id/src/lib/util/loading/dynamic_loader.cc	(revision 9707)
+++ branches/new_class_id/src/lib/util/loading/dynamic_loader.cc	(revision 9709)
@@ -31,5 +31,5 @@
 */
 DynamicLoader::DynamicLoader (const std::string& libName)
-    : Factory(NULL, 0)
+    : Factory(libName)
 {
   this->registerObject(this, DynamicLoader::_objectList);
Index: branches/new_class_id/src/lib/util/loading/factory.cc
===================================================================
--- branches/new_class_id/src/lib/util/loading/factory.cc	(revision 9707)
+++ branches/new_class_id/src/lib/util/loading/factory.cc	(revision 9709)
@@ -28,9 +28,10 @@
  * set everything to zero and define factoryName
  */
-Factory::Factory (const std::string& factoryName, int classID)
-    : _classID(classID), _className(factoryName)
+Factory::Factory (const NewClassID& classID)
+    : _classID(classID)
 {
-  this->registerObject(this, Factory::_objectList);
-  this->setName(factoryName);
+  printf("Factory::create(%s::%d)\n", classID.name().c_str(), classID.id());
+  //this->registerObject(this, Factory::_objectList);
+  this->setName(classID.name());
 
   if( Factory::_factoryList == NULL)
@@ -79,13 +80,4 @@
 }
 
-/**
- * @brief Compares the Factories Name against a given ClassName
- * @param className the Name of the Class to Query
- * @returns true on match, false otherwise.
- */
-bool Factory::operator==(const char* className) const
-{
-  return (className != NULL && this->_className == className);
-}
 
 /**
@@ -96,5 +88,5 @@
 bool Factory::operator==(const std::string& className) const
 {
-  return (this->_className == className);
+  return (this->_classID.name() == className);
 }
 
@@ -143,5 +135,4 @@
 }
 
-
 /**
  * @brief Creates a new Object of type classID
@@ -149,5 +140,5 @@
  * @returns a new Object of Type classID on match, NULL otherwise
  */
-BaseObject* Factory::fabricate(int classID)
+BaseObject* Factory::fabricate(const NewClassID& classID)
 {
   if (Factory::_factoryList == NULL)
@@ -157,21 +148,10 @@
   for (factory = Factory::_factoryList->begin(); factory != Factory::_factoryList->end(); factory++)
     if (*(*factory) == classID)
-    {
-      PRINTF(4)("Create a new Object of type %s\n", (*factory)->getCName());
-      return (*factory)->fabricateObject(NULL);
+  {
+    PRINTF(4)("Create a new Object of type %s\n", (*factory)->getCName());
+    return (*factory)->fabricateObject(NULL);
 
-    }
-  PRINTF(2)("Could not Fabricate an Object of ClassID '0x%h'\n", classID);
+  }
+  PRINTF(2)("Could not Fabricate an Object of ClassID '%d'\n", classID.id());
   return NULL;
 }
-
-
-/**
- * @brief Creates a new Object of type classID
- * @param classID the ClassID to match for the newly created Object
- * @returns a new Object of Type classID on match, NULL otherwise
- */
-BaseObject* Factory::fabricate(const NewClassID& classID)
-{
-  return Factory::fabricate(classID.id());
-}
Index: branches/new_class_id/src/lib/util/loading/factory.h
===================================================================
--- branches/new_class_id/src/lib/util/loading/factory.h	(revision 9707)
+++ branches/new_class_id/src/lib/util/loading/factory.h	(revision 9709)
@@ -20,6 +20,6 @@
 
 
-#ifndef _FACTORY_H
-#define _FACTORY_H
+#ifndef __FACTORY_H
+#define __FACTORY_H
 
 class BaseObject;
@@ -27,5 +27,4 @@
 #include "parser/tinyxml/tinyxml.h"
 #include "base_object.h"
-#include <vector>
 #include <list>
 
@@ -34,6 +33,6 @@
  * this should be used at the beginning of all the Classes that should be loadable (in the cc-file)
  */
-#define CREATE_FACTORY(CLASS_NAME, CLASS_ID) \
-    tFactory<CLASS_NAME>* global_##CLASS_NAME##_Factory = new tFactory<CLASS_NAME>(#CLASS_NAME, CLASS_ID)
+#define CREATE_FACTORY(CLASS_NAME) \
+    tFactory<CLASS_NAME>* global_##CLASS_NAME##_Factory = new tFactory<CLASS_NAME>(CLASS_NAME::classID())
 
 //! The Factory is a loadable object handler
@@ -48,19 +47,20 @@
   static  BaseObject* fabricate(const std::string& className);
   static  BaseObject* fabricate(const NewClassID& classID);
-  static  BaseObject* fabricate(int classID);
-  static  BaseObject* fabricate(const TiXmlElement* root = NULL);
+  static  BaseObject* fabricate(const TiXmlElement* root);
 
 
   bool operator==(int classID) const;
-  bool operator==(const char* className) const;
   bool operator==(const std::string& className) const;
+  bool operator==(const NewClassID& classID) const { return _classID == classID; };
 
 protected:
-  Factory (const std::string& factoryName, int classID);
+  Factory (const NewClassID& id);
   virtual BaseObject* fabricateObject(const TiXmlElement* root = NULL) const = 0;
 
+private:
+  Factory (const Factory&) {};
+
 protected:
-  const int                     _classID;              //!< The Class-Identifyer of the Factory.
-  const std::string             _className;            //!< The name of the Class.
+  const NewClassID              _classID;              //!< The Class-Identifyer of the Factory.
   static std::list<Factory*>*   _factoryList;          //!< List of Registered Factories
 };
@@ -78,9 +78,10 @@
    * @param classID the ID of the Class to be created.
    */
-  tFactory (const char* factoryName, int classID)
-      : Factory(factoryName, classID)
+  tFactory (const NewClassID& classID)
+      : Factory(classID)
   {  }
 
 private:
+  tFactory (const tFactory&) {};
   /**
    * @brief fabricates an Object of type T, with the constructor T::T(const TiXmlElemnt*)
Index: branches/new_class_id/src/lib/util/loading/fast_factory.cc
===================================================================
--- branches/new_class_id/src/lib/util/loading/fast_factory.cc	(revision 9709)
+++ branches/new_class_id/src/lib/util/loading/fast_factory.cc	(revision 9709)
@@ -0,0 +1,284 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Benjamin Grauer
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_LOAD
+
+#include "fast_factory.h"
+
+#include "compiler.h"
+#include "debug.h"
+#include <string.h>
+
+
+NewObjectListDefinition(FastFactory);
+
+/**
+ * @brief Initializes a FastFactory
+ * @param classID the ClassID this Class belongs to (the top-most)
+ * @param fastFactoryName the Name of the ObjectClass-handled here
+ * @return a new FastFactory
+ */
+FastFactory::FastFactory (const NewClassID& classID, const std::string& fastFactoryName)
+{
+  this->registerObject(this, FastFactory::_objectList);
+  this->setName(fastFactoryName);
+
+  this->storedClassID = classID;
+  this->next = NULL;
+
+  this->deadList = NULL;
+  this->unusedContainers = NULL;
+
+  this->storedDeadObjects = 0;
+
+  FastFactory::registerFastFactory(this);
+}
+
+/** a reference to the First FastFactory */
+FastFactory* FastFactory::first = NULL;
+
+/**
+ *  destructor
+ * deletes all the Instances of the FastFactory.
+ */
+FastFactory::~FastFactory ()
+{
+  if (this == first)
+    this->first = NULL;
+  this->flush();
+
+  if (this->next)
+    delete this->next;
+}
+
+/**
+ * deletes all FastFactories
+ */
+void FastFactory::deleteAll()
+{
+  if (FastFactory::first)
+    delete FastFactory::first;
+}
+
+/**
+ * registers a Factory to the List of known factories.
+ * @param fastFactory The factory to add
+ *
+ * needed, to step through all the FastFactories.
+ */
+void FastFactory::registerFastFactory(FastFactory* fastFactory)
+{
+  PRINTF(4)("Registered FastFactory for '%s'\n", fastFactory->getCName());
+
+  if( FastFactory::first == NULL)
+    FastFactory::first = fastFactory;
+  else
+  {
+    FastFactory* tmpFac = FastFactory::first;
+    while( tmpFac->next != NULL)
+      tmpFac = tmpFac->next;
+    tmpFac->setNext(fastFactory);
+  }
+}
+
+/**
+ * searches for a FastFactory
+ * @param classID the ClassID of the FastFactory to search for
+ * @returns true if found, false otherwise.
+ */
+FastFactory* FastFactory::searchFastFactory(const NewClassID& classID)
+{
+  if (FastFactory::first == NULL)
+    return NULL;
+  else
+  {
+    FastFactory* tmpFac = FastFactory::first;
+    while (tmpFac != NULL)
+    {
+      if (tmpFac->storedClassID == classID)
+        return tmpFac;
+      tmpFac = tmpFac->next;
+    }
+  }
+  return NULL;
+}
+
+/**
+ * searches for a FastFactory
+ * @param classID the ClassID of the FastFactory to search for
+ * @returns true if found, false otherwise.
+ */
+FastFactory* FastFactory::searchFastFactory(const std::string& fastFactoryName)
+{
+  if (FastFactory::first == NULL)
+    return NULL;
+  else
+  {
+    FastFactory* tmpFac = FastFactory::first;
+    while (tmpFac != NULL)
+    {
+      if (fastFactoryName == tmpFac->getCName())
+        return tmpFac;
+      tmpFac = tmpFac->next;
+    }
+  }
+  return NULL;
+}
+
+/**
+ * Removes all the stored Containers, and sets the Lists back to emptienes.
+ * @param hardFLUSH if true the containing Objects will also be deleted !! THIS IS DANGEROUS !!
+ */
+void FastFactory::flushAll(bool hardFLUSH)
+{
+  FastFactory* tmpFac = FastFactory::first;
+  while (tmpFac != NULL)
+  {
+    PRINTF(4)("DELETEING ALL OF %s\n",tmpFac->getCName());
+    tmpFac->flush(hardFLUSH);
+    tmpFac = tmpFac->next;
+  }
+}
+
+/**
+ * ereases all the remaining containers, without deleting the stored Objects inside of them.
+ * @param hardFLUSH if the the containing Objects will also be deleted !! THIS IS DANGEROUS !!
+ */
+void FastFactory::flush(bool hardFLUSH)
+{
+  FastObjectMember* tmpMember = this->deadList, *delMember = NULL;
+  while (tmpMember != NULL)
+  {
+    delMember = tmpMember;
+    tmpMember = tmpMember->next;
+    if (hardFLUSH)
+    {
+      delete delMember->objectPointer;
+    }
+    delete delMember;
+  }
+  this->deadList = NULL;
+
+  tmpMember = this->unusedContainers;
+  while (tmpMember != NULL)
+  {
+    delMember = tmpMember;
+    tmpMember = tmpMember->next;
+    delete delMember;
+  }
+  this->unusedContainers = NULL;
+}
+
+/**
+ * generates count new Object of the Corresponding class. (precaching)
+ * @param count How many instances of the class should be generated.
+ */
+void FastFactory::prepare(unsigned int count)
+{
+/*  if (this->storedDeadObjects + this->storedLivingObjects >= count)
+  {
+  PRINTF(3)("not creating new Objects for class %s, because the requested count already exists\n", this->getClassCName());
+}*/
+  for (unsigned int i = this->storedDeadObjects; i < count; i++)
+  {
+    this->fabricate();
+  }
+}
+
+/**
+ * gives back live to one Object.
+ * @return the Object to resurrect.
+ */
+BaseObject* FastFactory::resurrect()
+{
+  PRINTF(4)("Resurecting Object of type %s\n", this->getCName());
+  if (unlikely(this->deadList == NULL))
+  {
+    PRINTF(3)("The deadList of Class %s is empty, this may be either because it has not been filled yet, or the cache is to small.\n" \
+        "  Developer: try increasing the count with FastFactory::prepare(contHigher than actual)\n" \
+        "    Fabricating a new %s\n", this->getCName(), this->getCName());
+    this->fabricate();
+    return this->resurrect();
+  }
+  else
+  {
+    FastObjectMember* tmpC = this->deadList;
+    this->deadList = this->deadList->next;
+
+    tmpC->next = this->unusedContainers;
+    this->unusedContainers = tmpC;
+
+    return tmpC->objectPointer;
+  }
+}
+
+/**
+ * gives back live to one Object.
+ * @param classID the class From which to resurrect an Object.
+ * @return the Object to resurrect, NULL if classID is not found.
+ */
+BaseObject* FastFactory::resurrect(const NewClassID& classID)
+{
+  FastFactory* tmpFac = FastFactory::getFirst();
+
+  while (tmpFac != NULL)
+  {
+    if (classID == tmpFac->storedClassID)
+      return tmpFac->resurrect();
+    tmpFac = tmpFac->next;
+  }
+  return NULL;
+}
+
+/**
+ * kills Object object, meaning, that it will be stored in the deadList of the FastFactory, and waiting for resurrection
+ * @param object the Object to kill.
+ *
+ * synony that would be really grate would be abolish, but this is more like exterminate than pause-mode.
+ */
+void FastFactory::kill(BaseObject* object)
+{
+  FastObjectMember* tmpC;
+  if (unlikely(this->unusedContainers == NULL))
+  {
+    tmpC = new FastObjectMember;
+  }
+  else
+  {
+    tmpC = this->unusedContainers;
+    this->unusedContainers = this->unusedContainers->next;
+  }
+
+  tmpC->next = this->deadList;
+  tmpC->objectPointer = object;
+  this->deadList = tmpC;
+}
+
+
+void FastFactory::kill(BaseObject* object, bool searchForFastFactory)
+{
+  if (likely(searchForFastFactory == true))
+  {
+    FastFactory* tmpFac = FastFactory::first;
+    while (tmpFac != NULL)
+    {
+      if (object->isA(tmpFac->storedClassID))
+      {
+        tmpFac->kill(object);
+        return;
+      }
+      tmpFac = tmpFac->next;
+    }
+  }
+}
Index: branches/new_class_id/src/lib/util/loading/fast_factory.h
===================================================================
--- branches/new_class_id/src/lib/util/loading/fast_factory.h	(revision 9709)
+++ branches/new_class_id/src/lib/util/loading/fast_factory.h	(revision 9709)
@@ -0,0 +1,176 @@
+/*!
+ * @file fast_factory.h
+ * The ObjectManager (FastFactory) is designed, to automatically generate and remove
+ * (without to much overhead) many instances of different classes.
+ *
+ * It is especially usefull for objects, that come only for a short time into existence,
+ * and get killed after a small amount of time (like shots).
+ *
+ * The Creation of an Object is usually done in the Weapon Class, where one subscribes
+ * a Projectile with:
+ * this->bulletFactory = tFastFactory<TestBullet>::getFastFactory(CL_TEST_BULLET, "TestBullet");
+ * (this might change over time).
+ * Then you can at loading time initialize an amount of the class with something like:
+ * this->bulletFactory->prepare(100); // creates 100 entities of TestBullet (dead ones)
+ * afterwards one can just retrieve an Object form the Class with
+ * this->bulletFactory->resurrect();  // this returns a BaseObject an Object of the class.
+ *
+ * The big difference to the FastFactory-class is, that this one is used more for the purpose
+ * of fast game-interaction than for loading. althought one can also load FastFactorized classes
+ * it is not the main topic.
+ */
+
+#ifndef _FAST_FACTORY_H
+#define _FAST_FACTORY_H
+
+#include "base_object.h"
+/**
+ * Creates a FastFactory to a Createable FastFactory.
+ */
+#define CREATE_FAST_FACTORY(CLASS_NAME, CLASS_ID) \
+  FastFactory* global_##CLASS_NAME##_FastFactory = tFastFactory<CLASS_NAME>::getFastFactory(CLASS_ID, #CLASS_NAME)
+/**
+ * Creates a FastFactory for a Class' static function named ClassName::fastFactory.
+ * @param CLASS_NAME the name of the Class to create the fast-factory for.
+ * @param CLASS_ID the ID of the class to create the fast-factory for @see "class_id.h"
+ *
+ * notice, that the Class to be called, must implement:
+ * static FastFactory*         fastFactory;
+ */
+#define CREATE_FAST_FACTORY_STATIC(CLASS_NAME) \
+  FastFactory* CLASS_NAME::fastFactory = tFastFactory<CLASS_NAME>::getFastFactory(CLASS_NAME::classID(), #CLASS_NAME)
+
+//! A struct, that holds Lists of Objects of a certain type.
+typedef struct FastObjectMember
+{
+  BaseObject*          objectPointer;      //!< Pointer to the Object Stored in this Class (if it is the DeadList, else it is bork)
+
+  FastObjectMember*    next;               //!< the next stored FastObjectMember. (or NULL if this is the last one stored in either the deadList or the unusedContainers)
+};
+
+//! The FastFactory is a fast loadable object creator, and Dynamic List of dead object handler.
+/**
+ * The ObjectManager (FastFactory) is designed, to automatically generate and remove
+ * (without to much overhead) many instances of different classes.
+ *
+ * FastFactory is needed to glue all the tFastFactories together.
+ * It is also the general class that implements the necessary functions
+ * to generate, resurrect kill and stuff...
+ */
+class FastFactory : public BaseObject
+{
+  NewObjectListDeclaration(FastFactory);
+
+public:
+  virtual ~FastFactory ();
+  static void deleteAll();
+
+  // functions to push and pop elements of this class
+  BaseObject* resurrect();
+  static BaseObject* resurrect(const NewClassID& classID);
+  void kill(BaseObject* object);
+  static void kill(BaseObject* object, bool searchForFastFactory);
+
+  void prepare(unsigned int count);
+
+  static void flushAll(bool hardFLUSH = false);
+  void flush(bool hardFLUSH = false);
+
+  /** @returns the first FastFactory */
+  inline static FastFactory* getFirst() { return FastFactory::first; };
+
+  static FastFactory* searchFastFactory(const NewClassID& classID);
+  static FastFactory* searchFastFactory(const std::string& fastFactoryName);
+
+  const NewClassID& getStoredID() const { return this->storedClassID; };
+
+protected:
+  FastFactory (const NewClassID& classID, const std::string& fastFactoryName = "");
+
+  /** sets the Next factory in the list @param nextFactory the next factory */
+  inline void setNext( FastFactory* nextFastFactory) { this->next = nextFastFactory; };
+  /** @returns the next FastFactory */
+  FastFactory* getNext() const { return this->next; };
+
+  /** generates a new Object of the Class T */
+  virtual void fabricate() = 0;
+
+private:
+  static void registerFastFactory(FastFactory* fastFactory);
+
+protected:
+  NewClassID            storedClassID;        //!< The classID of the specified class.
+  unsigned int          storedDeadObjects;    //!< How many dead objects are stored in this class
+
+  FastObjectMember*     deadList;             //!< A List of all stored dead Objects of this class.
+  FastObjectMember*     unusedContainers;     //!< This is a List of unused containers, that will be reused by kill.
+
+private:
+  static FastFactory*   first;                //!< A pointer to the first FastFactory.
+
+  FastFactory*          next;                 //!< pointer to the next FastFactory.
+};
+
+
+
+/**
+ *  a FastFactory that is able to load any kind of Object from a ClassID
+ * (this is a Functor)
+ */
+template<class T>
+class tFastFactory : public FastFactory
+{
+public:
+  static tFastFactory<T>* getFastFactory(const NewClassID& classID, const std::string& fastFactoryName);
+
+private:
+  tFastFactory(const NewClassID& classID, const std::string& fastFactoryName);
+
+  virtual void fabricate();
+};
+
+/**
+ * construnts a FastFactory with
+ * @param fastFactoryName the name of the FastFactory
+ * @param fastFactory the ID of the class
+ * @todo (can this be written in another form??)
+ */
+template<class T>
+tFastFactory<T>::tFastFactory(const NewClassID& classID, const std::string& fastFactoryName)
+    : FastFactory(classID, fastFactoryName)
+{}
+
+/**
+ * creates (if not existent) a Factory of Class T, and assigns some values to it
+ * @param classID the ClassID to assign to this class
+ * @param fastFactoryName the name to assign
+ * @returns The FastFactory if existent a new Factory if not.
+ */
+template<class T>
+tFastFactory<T>* tFastFactory<T>::getFastFactory(const NewClassID& classID, const std::string& fastFactoryName)
+{
+  tFastFactory<T>* tmpFac = NULL;
+  if (FastFactory::getFirst() != NULL)
+    tmpFac = static_cast<tFastFactory<T>*>(FastFactory::getFirst()->searchFastFactory(classID));
+
+  if (tmpFac != NULL)
+    return tmpFac;
+  else
+    return new tFastFactory<T>(classID, fastFactoryName);
+}
+
+/**
+ * fabricates an Object of Class T, that corresponds to classID.
+ */
+template<class T>
+void tFastFactory<T>::fabricate()
+{
+  FastObjectMember* tmpFirstDead = new FastObjectMember;
+  tmpFirstDead->objectPointer = new T();
+  tmpFirstDead->next = this->deadList;
+  ++this->storedDeadObjects;
+
+  this->deadList = tmpFirstDead;
+}
+
+#endif /* _FAST_FACTORY_H */
Index: branches/new_class_id/src/orxonox.cc
===================================================================
--- branches/new_class_id/src/orxonox.cc	(revision 9707)
+++ branches/new_class_id/src/orxonox.cc	(revision 9709)
@@ -46,9 +46,8 @@
 
 #include "util/loading/factory.h"
-#include "fast_factory.h"
+#include "loading/fast_factory.h"
 
 #include "benchmark.h"
 
-#include "class_list.h"
 #include "shell_command_class.h"
 #include "shell_command.h"
@@ -97,4 +96,5 @@
 REGISTER_ARG_ARG(  _, write_dict,  "compression", "writedict",    "write packets to DATA/dicts/newdict",               "numBytes" );
 
+NewObjectListDefinition(Orxonox);
 
 /**
@@ -105,5 +105,5 @@
 Orxonox::Orxonox ()
 {
-  this->setClassID(CL_ORXONOX, "Orxonox");
+  this->registerObject(this, Orxonox::_objectList);
   this->setName("orxonox-main");
 
@@ -146,5 +146,7 @@
 
   SDL_QuitSubSystem(SDL_INIT_TIMER);
-  ClassList::debug();
+
+
+  NewObjectListBase::debugAll(1);
 
   Preferences::getInstance()->save();
Index: branches/new_class_id/src/orxonox.h
===================================================================
--- branches/new_class_id/src/orxonox.h	(revision 9707)
+++ branches/new_class_id/src/orxonox.h	(revision 9709)
@@ -16,4 +16,5 @@
 */
 class Orxonox : public BaseObject {
+  NewObjectListDeclaration(Orxonox);
 
  public:
Index: branches/new_class_id/src/story_entities/campaign.cc
===================================================================
--- branches/new_class_id/src/story_entities/campaign.cc	(revision 9707)
+++ branches/new_class_id/src/story_entities/campaign.cc	(revision 9709)
@@ -27,4 +27,5 @@
 
 
+NewObjectListDefinition(Campaign);
 
 /**
@@ -36,5 +37,5 @@
 Campaign::Campaign ( TiXmlElement* root)
 {
-  this->setClassID(CL_CAMPAIGN, "Campaign");
+  this->registerObject(this, Campaign::_objectList);
 
   PRINTF(4)("Loading Campaign...\n");
Index: branches/new_class_id/src/story_entities/campaign.h
===================================================================
--- branches/new_class_id/src/story_entities/campaign.h	(revision 9707)
+++ branches/new_class_id/src/story_entities/campaign.h	(revision 9709)
@@ -18,5 +18,5 @@
 class Campaign : public StoryEntity
 {
-
+  NewObjectListDeclaration(Campaign);
   public:
     Campaign( TiXmlElement* root);
Index: branches/new_class_id/src/story_entities/campaign_data.cc
===================================================================
--- branches/new_class_id/src/story_entities/campaign_data.cc	(revision 9707)
+++ branches/new_class_id/src/story_entities/campaign_data.cc	(revision 9709)
@@ -25,4 +25,5 @@
 
 
+NewObjectListDefinition(CampaignData);
 
 /**
@@ -31,5 +32,5 @@
 CampaignData::CampaignData(const TiXmlElement* root)
 {
-  this->setClassID(CL_CAMPAIGN_DATA, "CampaignData");
+  this->registerObject(this, CampaignData::_objectList);
 
   this->currentEntity = NULL;
Index: branches/new_class_id/src/story_entities/campaign_data.h
===================================================================
--- branches/new_class_id/src/story_entities/campaign_data.h	(revision 9707)
+++ branches/new_class_id/src/story_entities/campaign_data.h	(revision 9709)
@@ -16,4 +16,5 @@
 class CampaignData : public DataTank
 {
+  NewObjectListDeclaration(CampaignData);
 
 public:
Index: branches/new_class_id/src/story_entities/dedicated_server_world.cc
===================================================================
--- branches/new_class_id/src/story_entities/dedicated_server_world.cc	(revision 9707)
+++ branches/new_class_id/src/story_entities/dedicated_server_world.cc	(revision 9709)
@@ -21,5 +21,5 @@
 
 #include "util/loading/load_param.h"
-#include "fast_factory.h"
+#include "loading/fast_factory.h"
 #include "util/loading/factory.h"
 
